<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2020 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo
 * Release Date: 2019-01-08
 */
define('IN_DOUCO', true);

require (dirname(__FILE__) . '/include/init.php');

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 赋值给模板
$smarty->assign('rec', $rec);
$smarty->assign('cur', 'faq');

/**
 * +----------------------------------------------------------
 * 常见问题列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['faq']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['faq_add'],
            'href' => 'faq.php?rec=add' 
    ));
    
    // 获取参数
    $class = !$check->is_illegal_char($_REQUEST['class']) ? $_REQUEST['class'] : '';
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
 
    $where = $class ? " AND class = '$class'" : ''; // 分组
    if ($keyword) {
        $where = $where . " AND ask LIKE '%$keyword%'";
        $get = '&keyword=' . $keyword;
    }
 
    // 把第一个AND替换成WHERE
    $where = $dou->where($where);
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('faq') . $where . " ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $page_url = 'faq.php' . ($class ? '?class=' . $class : '');
    $limit = $dou->pager($sql, 15, $page, $page_url, $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $add_time = date("Y-m-d", $row['add_time']);
        
        $faq_list[] = array (
                "id" => $row['id'],
                "ask" => $row['ask'],
                "answer" => $row['answer'],
                "class" => $row['class'] ? $row['class'] : $_LANG['faq_class_no'],
                "add_time" => $add_time 
        );
    }
    
    // 赋值给模板
    $smarty->assign('keyword', $keyword);
    $smarty->assign('class_list', $dou->get_no_repeat_value('faq', 'class', $class));
    $smarty->assign('faq_list', $faq_list);
    
    $smarty->display('faq.htm');
} 

/**
 * +----------------------------------------------------------
 * 常见问题添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['faq_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['faq'],
            'href' => 'faq.php' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('class_list', $dou->get_no_repeat_value('faq', 'class'));
    $smarty->assign('faq', $faq);
    $smarty->assign('btn_lang', $dou->btn_lang('faq', '', 'ask, answer'));
    
    $smarty->display('faq.htm');
} 

elseif ($rec == 'insert') {
    // 验证问题
    if (empty($_POST['ask']))
        $dou->dou_msg($_LANG['faq_ask'] . $_LANG['is_empty']);
    
    // 验证答案
    if (empty($_POST['answer']))
        $dou->dou_msg($_LANG['faq_answer'] . $_LANG['is_empty']);
    
    // 数据格式化
    $add_time = time();
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "INSERT INTO " . $dou->table('faq') . " (id, ask, answer, `class`, add_time)" . " VALUES (NULL, '$_POST[ask]', '$_POST[answer]', '$_POST[class]', '$add_time')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['faq_add'] . ': ' . $_POST['ask']);
    $dou->dou_msg($_LANG['faq_add_succes'], 'faq.php');
} 

/**
 * +----------------------------------------------------------
 * 常见问题编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['faq_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['faq'],
            'href' => 'faq.php' 
    ));
    
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $faq = $dou->get_row('faq', '*', "id = '$id'");
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('class_list', $dou->get_no_repeat_value('faq', 'class', $faq['class']));
    $smarty->assign('faq', $faq);
    $smarty->assign('btn_lang', $dou->btn_lang('faq', $id, 'ask, answer'));
    
    $smarty->display('faq.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    // 验证问题
    if (empty($_POST['ask']))
        $dou->dou_msg($_LANG['faq_ask'] . $_LANG['is_empty']);
    
    // 验证答案
    if (empty($_POST['answer']))
        $dou->dou_msg($_LANG['faq_answer'] . $_LANG['is_empty']);
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
 
    $sql = "UPDATE " . $dou->table('faq') . " SET ask = '$_POST[ask]', answer = '$_POST[answer]', `class` = '$_POST[class]' WHERE id = '$id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['faq_edit'] . ': ' . $_POST['ask']);
    $dou->dou_msg($_LANG['faq_edit_succes'], 'faq.php');
}

/**
 * +----------------------------------------------------------
 * 常见问题删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'faq.php');
    $ask = $dou->get_one("SELECT ask FROM " . $dou->table('faq') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm'])) {
        // 删除对应语言项
        if ($_OPEN['language'])
            $dou->del_lang_value('faq', $id);
        
        $dou->create_admin_log($_LANG['faq_del'] . ': ' . $ask);
        $dou->delete('faq', "id = $id", 'faq.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $ask, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'faq.php', '', '30', "faq.php?rec=del&id=$id");
    }
} 

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'del_all') {
            // 批量常见问题删除
            $dou->del_all('faq', $_POST['checkbox'], 'id');
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        $dou->dou_msg($_LANG['faq_select_empty']);
    }
}

?>